:- dynamic pos/1.
:- dynamic neg/1.
/*
rule(1,d1,[m1,m2,m3]).
rule(2,d2,[m3,m4]).
rule(3,m1,[b1,b2,b3]).
rule(4,m4,[b2,b4]).
*/
rule(1,informatyka,[lubi_komputery,zna_angielski,mysli_analitycznie,mysli_po_inzyniersku]).

rule(2,gornictwo,[lubi_wegiel,kocha_slask,mysli_po_inzyniersku]).

rule(3,mysli_analitycznie,[rozwiazuje_sudoku,planuje_w_kalendarzu]).

rule(4,mysli_po_inzyniersku,[dokreca_srubki,rysuje_technicznie]).

rule(5,kocha_slask,[mieszka_familiok,godo_gwaro]).

% rule(6,na_drzewo, []).

decision(D):-
   rule(_,D,List),
   prove(List).
   
prove([]):-!.
prove([D|R]):- fact(D),prove(R).   

fact(D):- pos(D),!,write('Found in fact base: '),write(D),nl.
fact(D):- decision(D),assert(pos(D)),!,write('Proved and asserted: '),write(D),nl.
fact(D):- not(neg(D)), nl, write('Is that true: '),write(D),write('? '),
          read(X),X='yes',assert(pos(D)),!,write('Declared positive: '), write(D),nl.

fact(D):- not(neg(D)),write('Then probably no? '),
          read(X),X='no',assert(neg(D)),!,write('Declared negative: '), write(D),fail.
fact(D):- not(pos(D)),not(neg(D)),
          write('Once more please: yes/no'),fact(D),!.         

clear:- retract(pos(_)),fail.
clear:- retract(neg(_)),fail.
clear.


run:-
   write('A simple backward chaining interpreter'), nl, nl, 
   decision(D),
   nl, nl, write('Suggested decision: '), write(D), nl, nl,
   clear.


